---
title: VRDevice.hardwareUnitId
slug: Web/API/VRDisplay/hardwareUnitId
tags:
  - API
  - Experimental
  - Obsolete
  - Property
  - Reference
  - VR
  - VRDevice
  - Virtual Reality
  - WebVR
  - hardwareUnitId
---
<div>{{obsolete_header()}}{{APIRef("WebVR API")}}{{SeeCompatTable}}</div>

<p>The <strong><code>hardwareUnitId</code></strong> read-only property of the {{domxref("VRDevice")}} interface returns the distinct hardware ID for the overall hardware unit that this <code>VRDevice</code> is a part of. All devices that are part of the same physical piece of hardware will have the same <code>hardwareUnitId</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">var hardwareID = VRDevice.hardwareUnitId;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} containing the ID of the overall hardware unit.</p>

<h2 id="Examples">Examples</h2>

<p>The following snippet (see our <a href="https://mdn.github.io/webvr-tests/vrdevice/">VRDevice example</a>) returns an array of all the {{domxref("VRDevice")}}s connected to your computer via {{domxref("Navigator.getVRDevices()")}}. For each connected device it then prints out the <code>hardwareUnitId</code>, {{domxref("VRDevice.deviceId")}}, and {{domxref("VRDevice.deviceName")}}.</p>

<pre class="brush: js">var list = document.querySelector('ul');
var info = document.querySelector('p');
if(navigator.getVRDevices) {
  navigator.getVRDevices().then(function(myDevices) {
    reportDevices(myDevices);
  });
} else {
  info.textContent = 'WebVR API not supported by this browser.'
}

function reportDevices(devices) {
  for(i = 0; i &lt; devices.length; i++) {
    var listItem = document.createElement('li');
    listItem.innerHTML = 'Device ' + (i+1)
                 + ': &lt;strong&gt;Hardware ID&lt;/strong&gt;: ' + devices[i].hardwareUnitId
                 + ', &lt;strong&gt;VD Device ID&lt;/strong&gt;: ' + devices[i].deviceId
                 + ', &lt;strong&gt;VR Device Name&lt;/strong&gt;: ' + devices[i].deviceName
                 + '.';
    list.appendChild(listItem);
  }
}</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.VRDisplay.hardwareUnitId")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebVR_API">WebVR API homepage</a>.</li>
 <li><a href="http://mozvr.com/">MozVr.com</a> — demos, downloads, and other resources from the Mozilla VR team.</li>
</ul>
